#include<iostream>
#include<cstdlib>
#include<ctime>
#include"pgcd.hpp"

using namespace std;

int pgcd(int a, int b){
    if(( a==0 ) && ( b==0 )){
        cout << "Erreur" << endl;
        return 0;
    }

    if(a<0){ a = -a; }
    if(b<0)
        b = -b;

    if(a==0) return b;

    int c;

    for(int i = 1; i <= a; i++){
        if((a%i == 0) && (b%i == 0)){
            c = i;
        }
    }

    return c;
}


int pgcd_fast(int a, int b){
    if(( a==0 ) && ( b==0 )){
        cout << "Erreur" << endl;
        return 0;
    }

    if(a<0){ a = -a; }
    if(b<0)
        b = -b;

    int ap, bp;

    while(b !=0){
        ap = b;
        bp = a%b;

        a = ap;
        b = bp;
    }

    return a;
}


double probRelPrime(int n){
    int compteur = 0;

    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=n; j++){
            if(pgcd_fast(i,j) == 1){
                compteur++;
            }
        }
    }

    double p =(double)compteur / (n*n);
    return p;
}

double probRelPrime_fast(int n, int m){
    int a,b;
    int compteur = 0;

    srand(time(0));

    for(int i = 1; i<=m; i++){
        a = n*((double)rand()/RAND_MAX) + 1;
        b = n*((double)rand()/RAND_MAX) + 1;
        if(pgcd_fast(a,b) == 1){
            compteur++;
        }
    }

    double p = (double)compteur / m;
    return p;
}
